
#include <iostream.h>
#include <conio.h>
#include <stdlib.h>
#include <conio.h>

#include "mywin.h"

//================================[ win_blk ]=================================

 win_blk::win_blk(int lt, int tp, int rt, int bm){
		int blk_size;
		left=lt;
		top=tp;
		right=rt;
		bottom=bm;
		blk_size=(bottom-top+1) * (right-left+3)* 2;
		buffer=(char *)malloc(blk_size);
		gettextinfo(&cur_blk);
		gettext(lt,tp,rt,bm,buffer);
		window(left,top,right,bottom);

}
 win_blk::~win_blk(void){
        puttext(left,top,right,bottom,buffer);
        if((buffer)!=NULL)      free(buffer);
        window( cur_blk.winleft,
                cur_blk.wintop,
                cur_blk.winright,
                cur_blk.winbottom);
        textattr(cur_blk.attribute);
        gotoxy(cur_blk.curx,cur_blk.cury);
}



//=============================[ border_blk ]================================

 border_blk::border_blk (int lt, int tp, int rt, int bm)\
			:win_blk(lt-1,tp-1,rt,bm+2)
 {
		draw_box(lt-1,tp-1,rt,bm+2,1);
		window( lt,tp,rt-1,bm);
		clrscr();
 }


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


void txt_length_depth(char *str, int &length, int &depth)
{
	int cntr=0;
	length=depth=0;
	char *ptr;
	ptr=str;
	while(*ptr!='\0'){
		if(*ptr=='\n') {
			if(cntr>length) length=cntr;
			cntr=0;
			depth++;
		} else cntr++;
	ptr++;
	}
}


void calc_win_size(char *str,int &tc, int &tr, int &bc, int &br)
{
	int length,depth;
	txt_length_depth(str,length,depth);

	if(depth > 22){
		tr=1;
		depth=21;
	}else tr=(24-depth)/2;

	if(length > 78){
		tc=1;
		length=77;
	} else tc=(80-length)/2;

	br=tr+depth;
	bc=tc+length;
}


void draw_box(int startx, int starty, int endx, int endy, int type)
{
	register int i;
	unsigned char bx[][6]= {{'','','','','',''},
							{'','','','','',''}};


	//:::::[ DISPLAY TOP LINE ]:::::::

	gotoxy(1,1);
	putch(bx[type][0]);
	for(i=0;i<=endx-startx-2;i++)	putch(bx[type][4]);
	putch(bx[type][1]);

	

	//:::::[ DISPLAY BOTTOM LINE ]::::

	gotoxy(1,endy-starty);
	putch(bx[type][2]);
	for (i=0;i<=endx-startx-2;i++) putch(bx[type][4]);
	putch(bx[type][3]);


	//:::::[ DISPLAY VERTICAL LINES ]:

	for(i=2;i<endy-starty;i++){
		gotoxy(1,i);
		putch(bx[type][5]);
		gotoxy(endx-startx+1,i);
		putch(bx[type][5]);
	}

}



//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------



#define CR "\r\n"
#define setattr(f,b) textattr(f|b<<4)


main(){
	int lh,dh;  // length and depth
	int tc,tr,bc,br;

	char *str=
	" 1) This is a test to see how long the longest string is"CR
	" 2) data is returned in length and depth variables "CR
	"           1         2         3         4         5         6"CR
	" 0123456789012345678901234567890123456789012345678901234567890";


	char *str1=
	" This is a second string being displayed"CR
	" on the screen";

	clrscr();
	txt_length_depth(str,lh,dh);
	cout << str << "\n\ntxt_length_depth(char *str, int &length, int &depth";
	cout << "\n\tlength=" << lh << "  depth=" << dh;

	calc_win_size(str,tc,tr,bc,br);
	cout << "\n\ncalc_win_size(char *str, int &tc, int &tr, int &bc, int &br)";
	cout << "\n\ttc=" << tc << " tr=" << tr << " bc=" << bc << " br=" << br << "\n\n";


	getch();

	{	// SCOPE: This will allow both windows to be displayed at once

		setattr(WHITE,BLUE);
		calc_win_size(str,tc,tr,bc,br);
		border_blk wintst(tc,tr,bc,br);
		cprintf(str);
		getch();

		{ // SCOPE: This will only show this string (box) while in this scope.

			setattr(YELLOW,CYAN);
			calc_win_size(str1,tc,tr,bc,br);
			border_blk wintst1(tc,tr,bc,br);
			cprintf(str1);
			getch();

		} // Destructor kicks in here for this scope

		getch();

	} // Destructor kicks in here for this scope

	getch();

	setattr(LIGHTGRAY,BLACK);
	cprintf(str);
}


